

from forum.handler.BaseHandler import BaseHandler
from forum.decorators import login_required_async
from forum.models import CollectionModel, TopicModel, UserModel

class AddCollectionHandler(BaseHandler):
    @login_required_async
    async def post(self):
        try:
            id = self.get_body_argument('id')
            user = await self.obj.get(UserModel,id = self._user_id)
            topic = await self.obj.get(TopicModel,id = id)
            await self.obj.create(CollectionModel,user = user, topic = topic)
            return self.finish({'msg':'收藏成功','code':200})
        except Exception as e :
            return self.finish({'msg':'收藏失败','code':500})

#我的收藏
class GetMyCollectionHandler(BaseHandler):
    @login_required_async
    async def post(self):
        collections= await self.obj.execute(CollectionModel.select().join(UserModel).where(UserModel.id == self._user_id))
        data = []
        for c in collections:
            d = {}
            d['user'] = c.user.to_json()
            d['topic'] = c.topic.to_json()
            del d['topic']['content']
            del d['topic']['imgs']
            del d['topic']['user']
            data.append(d)
        return self.finish({'msg':'获取收藏成功','code':200,'collection':data})


#删除收藏
class DeleteCollectionHandler(BaseHandler):
    @login_required_async
    async def post(self):
        tid = self.get_body_argument('id')
        try:
            topic = await self.obj.get(TopicModel,id = tid)  #外键取消收藏的方法
            user = await self.obj.get(UserModel,id = self._user_id)
            rs = await self.obj.execute(CollectionModel.delete().where(CollectionModel.user == user,CollectionModel.topic == topic))
            return self.finish({'msg':'取消收藏成功','code':200})
        except Exception as e:
            return self.finish({'msg':'取消收藏失败','code':500})


