

from forum.handler.BaseHandler import BaseHandler
from forum.models import TopicModel, UserModel
from forum.models import CommentModel
from uuid import uuid4
from forum.decorators import login_required_async

#获取帖子评论信息 我的
# class GetCommentHandler(BaseHandler):
#     async def post(self):
#         id = self.get_body_argument('id')
#         comments = await self.obj.execute(CommentModel.select().join(TopicModel).where(TopicModel.id == id))
#         data = []
#         for comment in comments:
#             c = comment.to_json()
#             c['user'] = c.get('user').to_json()
#             del c['topic']
#             data.append(c)
#         return self.finish({'msg':'获取评论成功','code':200,'comment':data})

class GetCommentHandler(BaseHandler):
    async def post(self):
        id = self.get_body_argument('id')
        comments = await self.obj.execute(CommentModel.select().join(TopicModel).where(TopicModel.id == id))
        data =  []
        for comment in comments:
            c = comment.to_json()
            c['user'] = c.get('user').to_json()
            del c['topic']
            data.append(c)
        return self.finish({'msg':'获取评论成功','code':200,'comments':data})

#发表评论   我的
class AddCommentHandler(BaseHandler):
    @login_required_async
    async def post(self):
        content = self.get_body_argument('content')
        topic_id = self.get_body_argument('topic_id')
        user = await self.obj.get(UserModel,id=self._user_id)
        topic = await self.obj.get(TopicModel,id = topic_id)  #错误，写成 TopicModelid
        await self.obj.create(CommentModel,id = uuid4(),content = content,user =user,topic=topic)
        return self.finish({'msg':'发表成功','code':200})


#获取个人发帖
class GetMyCommentHandler(BaseHandler):
    @login_required_async
    async def post(self):
        comments = await self.obj.execute(CommentModel.select().join(UserModel).where(UserModel.id ==self._user_id))
        data =  []
        for comment in comments:
            c = comment.to_json()
            c['user'] = c.get('user').to_json()
            del c['topic']
            data.append(c)
        return self.finish({'msg':'获取评论成功','code':200,'comments':data}) 


