
from forum.handler.BaseHandler import BaseHandler
from forum.models import FollowModel, UserModel
from forum.decorators import login_required_async

#增加我的关注
class AddFollowHandler(BaseHandler):
    @login_required_async
    async def post(self):
        try:
            uid = self.get_body_argument('id')
            to_user = await self.obj.get(UserModel,id = uid)
            my = await self.obj.get(UserModel,id = self._user_id)
            await self.obj.create(FollowModel,to_user = to_user,from_user = my)
            return self.finish({'msg':'关注成功','code':200})
        except Exception as e:
            return self.finish({'msg':'关注失败','code':500})


#获得关注信息
class GetFollowHandler(BaseHandler):
    @login_required_async
    async def post(self):
        try:
            id = self.get_body_argument('id')
            follow=await self.obj.get(UserModel.select().join(FollowModel,on = FollowModel.to_user).where(FollowModel.from_user == self._user_id,FollowModel.to_user == id))
            return self.finish({'msg':'已关注','code':200,'flag':True})
        except Exception as e:
            return self.finish({'msg':'未关注','code':200,'flag':False})



